## qubes-gui-agent 4.1.15

=== Makefile ===
#
# The Qubes OS Project, http://www.qubes-os.org
#
# Copyright (C) 2010  Joanna Rutkowska <joanna@invisiblethingslab.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#

VERSION := $(shell cat version)
LIBDIR ?= /usr/lib64
USRLIBDIR ?= /usr/lib
SYSLIBDIR ?= /lib
DATADIR ?= /usr/share
PA_VER_FULL ?= $(shell pkg-config --modversion libpulse | cut -d "-" -f 1 || echo 0.0)
PA_VER_MAJOR_MINOR ?= $(shell echo $(PA_VER_FULL) | cut -d "." -f 1,2)

help:
	@echo "Qubes GUI main Makefile:" ;\
	    echo; \
	    echo "make clean                <--- clean all the binary files";\
	    @exit 0;

appvm: gui-agent/qubes-gui gui-common/qubes-gui-runuser \
	xf86-input-mfndev/src/.libs/qubes_drv.so \
	xf86-video-dummy/src/.libs/dummyqbs_drv.so pulse/module-vchan-sink.so \
	xf86-qubes-common/libxf86-qubes-common.so

gui-agent/qubes-gui:
	$(MAKE) -C gui-agent

gui-common/qubes-gui-runuser:
	$(MAKE) -C gui-common

xf86-input-mfndev/src/.libs/qubes_drv.so: xf86-qubes-common/libxf86-qubes-common.so
	(cd xf86-input-mfndev && ./autogen.sh && ./configure)
	$(MAKE) -C xf86-input-mfndev

xf86-video-dummy/src/.libs/dummyqbs_drv.so: xf86-qubes-common/libxf86-qubes-common.so
	(cd xf86-video-dummy && ./autogen.sh)
	$(MAKE) -C xf86-video-dummy

pulse/module-vchan-sink.so:
	rm -f pulse/pulsecore
	ln -s pulsecore-$(PA_VER_FULL) pulse/pulsecore
	$(MAKE) -C pulse module-vchan-sink.so

xf86-qubes-common/libxf86-qubes-common.so:
	$(MAKE) -C xf86-qubes-common libxf86-qubes-common.so

tar:
	git archive --format=tar --prefix=qubes-gui/ HEAD -o qubes-gui.tar

clean:
	(cd common && $(MAKE) clean)
	(cd gui-agent && $(MAKE) clean)
	(cd gui-common && $(MAKE) clean)
	$(MAKE) -C pulse clean
	$(MAKE) -C xf86-qubes-common clean
	(cd xf86-input-mfndev; if [ -e Makefile ] ; then \
		$(MAKE) distclean; fi; ./bootstrap --clean || echo )
	rm -rf debian/changelog.*
	rm -rf pkgs


install: install-rh-agent install-pulseaudio

install-rh-agent: appvm install-common
	install -m 0644 -D appvm-scripts/qubes-gui-agent.service \
		$(DESTDIR)/$(SYSLIBDIR)/systemd/system/qubes-gui-agent.service
	install -m 0644 -D appvm-scripts/etc/sysconfig/desktop \
		$(DESTDIR)/etc/sysconfig/desktop
	install -D appvm-scripts/etc/X11/xinit/xinitrc.d/20qt-x11-no-mitshm.sh \
		$(DESTDIR)/etc/X11/xinit/xinitrc.d/20qt-x11-no-mitshm.sh
	install -D appvm-scripts/etc/X11/xinit/xinitrc.d/20qt-gnome-desktop-session-id.sh \
		$(DESTDIR)/etc/X11/xinit/xinitrc.d/20qt-gnome-desktop-session-id.sh
	install -D appvm-scripts/etc/X11/xinit/xinitrc.d/50guivm-windows-prefix.sh \
		$(DESTDIR)/etc/X11/xinit/xinitrc.d/50guivm-windows-prefix.sh
	install -D appvm-scripts/etc/X11/xinit/xinitrc.d/60xfce-desktop.sh \
		$(DESTDIR)/etc/X11/xinit/xinitrc.d/60xfce-desktop.sh

install-debian: appvm install-common install-pulseaudio
	install -d $(DESTDIR)/etc/X11/Xsession.d
	install -m 0644 appvm-scripts/etc/X11/Xsession.d/* $(DESTDIR)/etc/X11/Xsession.d/
	install -d $(DESTDIR)/etc/xdg
	install -m 0644 appvm-scripts/etc/xdg-debian/* $(DESTDIR)/etc/xdg
	install -m 0644 -D appvm-scripts/qubes-gui-agent.service \
		$(DESTDIR)/$(SYSLIBDIR)/systemd/system/qubes-gui-agent.service

install-pulseaudio:
	install -D pulse/start-pulseaudio-with-vchan \
		$(DESTDIR)/usr/bin/start-pulseaudio-with-vchan
	install -m 0644 -D pulse/qubes-default.pa \
		$(DESTDIR)/etc/pulse/qubes-default.pa
	install -D pulse/module-vchan-sink.so \
		$(DESTDIR)$(LIBDIR)/pulse-$(PA_VER_MAJOR_MINOR)/modules/module-vchan-sink.so
	install -m 0644 -D appvm-scripts/etc/tmpfiles.d/qubes-pulseaudio.conf \
		$(DESTDIR)/$(USRLIBDIR)/tmpfiles.d/qubes-pulseaudio.conf
	install -m 0644 -D appvm-scripts/etc/xdgautostart/qubes-pulseaudio.desktop \
		$(DESTDIR)/etc/xdg/autostart/qubes-pulseaudio.desktop

install-common:
	install -D gui-agent/qubes-gui $(DESTDIR)/usr/bin/qubes-gui
	install -D gui-common/qubes-gui-runuser $(DESTDIR)/usr/bin/qubes-gui-runuser
	install -d $(DESTDIR)/etc/qubes/post-install.d
	install -m 0755 appvm-scripts/etc/qubes/post-install.d/20-qubes-guivm-gui-agent.sh \
                $(DESTDIR)/etc/qubes/post-install.d/20-qubes-guivm-gui-agent.sh
	install -D appvm-scripts/usrbin/qubes-session \
		$(DESTDIR)/usr/bin/qubes-session
	install -D appvm-scripts/usrbin/qubes-run-xorg \
		$(DESTDIR)/usr/bin/qubes-run-xorg
	install -D appvm-scripts/usrbin/qubes-run-xephyr \
		$(DESTDIR)/usr/bin/qubes-run-xephyr
	install -D appvm-scripts/usrbin/qubes-start-xephyr \
		$(DESTDIR)/usr/bin/qubes-start-xephyr
	install -D appvm-scripts/usrbin/qubes-change-keyboard-layout \
		$(DESTDIR)/usr/bin/qubes-change-keyboard-layout
	install -D appvm-scripts/usrbin/qubes-set-monitor-layout \
		$(DESTDIR)/usr/bin/qubes-set-monitor-layout
	install -D xf86-qubes-common/libxf86-qubes-common.so \
		$(DESTDIR)$(LIBDIR)/libxf86-qubes-common.so
	install -D xf86-input-mfndev/src/.libs/qubes_drv.so \
		$(DESTDIR)$(LIBDIR)/xorg/modules/drivers/qubes_drv.so
	install -D xf86-video-dummy/src/.libs/dummyqbs_drv.so \
		$(DESTDIR)$(LIBDIR)/xorg/modules/drivers/dummyqbs_drv.so
	install -m 0644 -D appvm-scripts/etc/X11/xorg-qubes.conf.template \
		$(DESTDIR)/etc/X11/xorg-qubes.conf.template
	install -m 0644 -D appvm-scripts/etc/profile.d/qubes-gui.sh \
		$(DESTDIR)/etc/profile.d/qubes-gui.sh
	install -m 0644 -D appvm-scripts/etc/profile.d/qubes-gui.csh \
		$(DESTDIR)/etc/profile.d/qubes-gui.csh
	install -m 0644 -D appvm-scripts/etc/securitylimits.d/90-qubes-gui.conf \
		$(DESTDIR)/etc/security/limits.d/90-qubes-gui.conf
ifneq ($(shell lsb_release -is), Ubuntu)
	install -m 0644 -D appvm-scripts/etc/xdg/Trolltech.conf \
		$(DESTDIR)/etc/xdg/Trolltech.conf
endif
	install -m 0644 -D appvm-scripts/qubes-gui-vm.gschema.override \
		$(DESTDIR)$(DATADIR)/glib-2.0/schemas/20_qubes-gui-vm.gschema.override
	install -d $(DESTDIR)/etc/qubes-rpc
	ln -s ../../usr/bin/qubes-set-monitor-layout \
		$(DESTDIR)/etc/qubes-rpc/qubes.SetMonitorLayout
	ln -s ../../usr/bin/qubes-start-xephyr \
		$(DESTDIR)/etc/qubes-rpc/qubes.GuiVMSession
	install -D window-icon-updater/icon-sender \
		$(DESTDIR)/usr/lib/qubes/icon-sender
	install -m 0644 -D window-icon-updater/qubes-icon-sender.desktop \
		$(DESTDIR)/etc/xdg/autostart/qubes-icon-sender.desktop
	install -m 0644 -D appvm-scripts/etc/xdgautostart/qubes-qrexec-fork-server.desktop \
		$(DESTDIR)/etc/xdg/autostart/qubes-qrexec-fork-server.desktop
	install -m 0644 -D appvm-scripts/etc/xdgautostart/qubes-keymap.desktop \
		$(DESTDIR)/etc/xdg/autostart/qubes-keymap.desktop
	install -D -m 0644 appvm-scripts/usr/lib/sysctl.d/30-qubes-gui-agent.conf \
		$(DESTDIR)/usr/lib/sysctl.d/30-qubes-gui-agent.conf
	install -D -m 0644 appvm-scripts/lib/udev/rules.d/70-master-of-seat.rules \
		$(DESTDIR)/$(SYSLIBDIR)/udev/rules.d/70-master-of-seat.rules
	install -D appvm-scripts/usr/lib/qubes/qubes-gui-agent-pre.sh \
		$(DESTDIR)/usr/lib/qubes/qubes-gui-agent-pre.sh
	install -D appvm-scripts/usr/lib/qubes/qubes-keymap.sh \
		$(DESTDIR)/usr/lib/qubes/qubes-keymap.sh
ifeq ($(shell lsb_release -is), Debian)
	install -D -m 0644 appvm-scripts/etc/pam.d/qubes-gui-agent.debian \
		$(DESTDIR)/etc/pam.d/qubes-gui-agent
else ifeq ($(shell lsb_release -is), Ubuntu)
	install -D -m 0644 appvm-scripts/etc/pam.d/qubes-gui-agent.debian \
		$(DESTDIR)/etc/pam.d/qubes-gui-agent
else ifeq ($(shell lsb_release -is), Arch)
	install -D -m 0644 appvm-scripts/etc/pam.d/qubes-gui-agent.archlinux \
		$(DESTDIR)/etc/pam.d/qubes-gui-agent
else
	install -D -m 0644 appvm-scripts/etc/pam.d/qubes-gui-agent \
		$(DESTDIR)/etc/pam.d/qubes-gui-agent
endif
	install -d $(DESTDIR)/var/log/qubes

=== debian/changelog ===
qubes-gui-agent (4.1.15-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Tue, 05 Jan 2021 22:23:18 +0100

qubes-gui-agent (4.1.15-1) unstable; urgency=medium

  [ Frédéric Pierret (fepitre) ]
  * debian: update control
  * debian: update compat

  [ Benjamin Moody ]
  * vmside: Rename wm_state to net_wm_state.
  * vmside: Implement the WM_STATE property.

  [ Demi Marie Obenour ]
  * Remove unnecessary XInternAtom
  * Move XInternAtom calls to startup
  * Log when an unmanaged window is skipped
  * Add Vim modeline
  * Delete commented-out code
  * Use actual X11 timestamps
  * Only set focus on windows that want it
  * Tell Java we are a non-reparenting window manager
  * Remove references to /tmp/qubes-session-{env,waiter}
  * Remove unneded time parameters
  * Avoid passing NULL as an X11 string

  [ Marek Marczykowski-Górecki ]
  * Start gui-agent only after systemd let in normal users

  [ Demi Marie Obenour ]
  * Mass replace: ‘/var/run’ → ‘/run’

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 05 Jan 2021 22:23:18 +0100

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+fixfilepath
DPKG_EXPORT_BUILDFLAGS = 1

include /usr/share/dpkg/default.mk
export DESTDIR=$(shell pwd)/debian/tmp
export LIBDIR=/usr/lib

PA_VER=$(shell pkg-config --modversion libpulse | cut -d "-" -f 1 || echo 0.0)

%:
	dh $@ --with systemd,xsf

override_dh_auto_build:
	make appvm

override_dh_auto_install:
	make install-debian

override_dh_systemd_start:
	dh_systemd_start --no-restart-on-upgrade

override_dh_install:
	dh_install --fail-missing

override_dh_gencontrol:
	echo "pulse:Depends=pulseaudio (>= $(PA_VER)), pulseaudio (<< $(PA_VER).1)" >> debian/pulseaudio-qubes.substvars
	dh_gencontrol

## qubes-gui-agent 4.1.16

=== debian/changelog ===
qubes-gui-agent (4.1.16-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Sat, 13 Feb 2021 12:30:55 +0100

qubes-gui-agent (4.1.16-1) unstable; urgency=medium

  [ Marek Marczykowski-Górecki ]
  * debian: prevent restart on update
  * Add pulseaudio-14.1 headers
  * Add pulseaudio 14.2 headers

  [ unman ]
  * Fix pulseaudio in Ubuntu templates

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sat, 13 Feb 2021 12:30:55 +0100

## qubes-gui-agent 4.1.17

=== Makefile ===
--- 
+++ 
@@ -104,8 +104,13 @@
 		$(DESTDIR)/usr/bin/start-pulseaudio-with-vchan
 	install -m 0644 -D pulse/qubes-default.pa \
 		$(DESTDIR)/etc/pulse/qubes-default.pa
+ifneq ($(shell lsb_release -is), Ubuntu)
 	install -D pulse/module-vchan-sink.so \
 		$(DESTDIR)$(LIBDIR)/pulse-$(PA_VER_MAJOR_MINOR)/modules/module-vchan-sink.so
+else
+	install -D pulse/module-vchan-sink.so \
+		$(DESTDIR)$(LIBDIR)/pulse-$(PA_VER_FULL)/modules/module-vchan-sink.so
+endif
 	install -m 0644 -D appvm-scripts/etc/tmpfiles.d/qubes-pulseaudio.conf \
 		$(DESTDIR)/$(USRLIBDIR)/tmpfiles.d/qubes-pulseaudio.conf
 	install -m 0644 -D appvm-scripts/etc/xdgautostart/qubes-pulseaudio.desktop \

=== gui-agent/Makefile ===
#
# The Qubes OS Project, http://www.qubes-os.org
#
# Copyright (C) 2010  Rafal Wojtczuk  <rafal@invisiblethingslab.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#

CC ?= gcc
CFLAGS += -I../include/ `pkg-config --cflags vchan` -g -Wall -Wextra -Werror -pie -fPIC
OBJS = vmside.o \
	../gui-common/txrx-vchan.o ../gui-common/error.o ../common/list.o ../gui-common/encoding.o 
LIBS = -lX11 -lXdamage -lXcomposite -lXfixes `pkg-config --libs vchan` -lqubesdb


all: qubes-gui
qubes-gui: $(OBJS)
	$(CC) $(LDFLAGS) -pie -g -o qubes-gui $(OBJS) \
		$(LIBS)
clean:
	rm -f qubes-gui *.o *~

=== debian/changelog ===
qubes-gui-agent (4.1.17-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Mon, 05 Apr 2021 16:38:49 +0200

qubes-gui-agent (4.1.17-1) unstable; urgency=medium

  [ Rusty Bird ]
  * vmside: make strncat() length more obvious

  [ Frédéric Pierret (fepitre) ]
  * get-latest-pulsecore: default value for latest Fedora release

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Mon, 05 Apr 2021 16:38:49 +0200

## qubes-gui-agent 4.1.18

=== debian/changelog ===
qubes-gui-agent (4.1.18-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Sat, 12 Jun 2021 17:57:09 +0200

qubes-gui-agent (4.1.18-1) unstable; urgency=medium

  [ Frédéric Pierret (fepitre) ]
  * spec: ensure R for few x11 tools

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sat, 12 Jun 2021 17:57:09 +0200

## qubes-gui-agent 4.1.19

=== Makefile ===
--- 
+++ 
@@ -77,9 +77,7 @@
 
 install: install-rh-agent install-pulseaudio
 
-install-rh-agent: appvm install-common
-	install -m 0644 -D appvm-scripts/qubes-gui-agent.service \
-		$(DESTDIR)/$(SYSLIBDIR)/systemd/system/qubes-gui-agent.service
+install-rh-agent: appvm install-common install-systemd
 	install -m 0644 -D appvm-scripts/etc/sysconfig/desktop \
 		$(DESTDIR)/etc/sysconfig/desktop
 	install -D appvm-scripts/etc/X11/xinit/xinitrc.d/20qt-x11-no-mitshm.sh \
@@ -91,13 +89,11 @@
 	install -D appvm-scripts/etc/X11/xinit/xinitrc.d/60xfce-desktop.sh \
 		$(DESTDIR)/etc/X11/xinit/xinitrc.d/60xfce-desktop.sh
 
-install-debian: appvm install-common install-pulseaudio
+install-debian: appvm install-common install-pulseaudio install-systemd
 	install -d $(DESTDIR)/etc/X11/Xsession.d
 	install -m 0644 appvm-scripts/etc/X11/Xsession.d/* $(DESTDIR)/etc/X11/Xsession.d/
 	install -d $(DESTDIR)/etc/xdg
 	install -m 0644 appvm-scripts/etc/xdg-debian/* $(DESTDIR)/etc/xdg
-	install -m 0644 -D appvm-scripts/qubes-gui-agent.service \
-		$(DESTDIR)/$(SYSLIBDIR)/systemd/system/qubes-gui-agent.service
 
 install-pulseaudio:
 	install -D pulse/start-pulseaudio-with-vchan \
@@ -116,6 +112,10 @@
 	install -m 0644 -D appvm-scripts/etc/xdgautostart/qubes-pulseaudio.desktop \
 		$(DESTDIR)/etc/xdg/autostart/qubes-pulseaudio.desktop
 
+install-systemd:
+	install -m 0644 -D appvm-scripts/qubes-gui-agent.service \
+		$(DESTDIR)/$(SYSLIBDIR)/systemd/system/qubes-gui-agent.service
+
 install-common:
 	install -D gui-agent/qubes-gui $(DESTDIR)/usr/bin/qubes-gui
 	install -D gui-common/qubes-gui-runuser $(DESTDIR)/usr/bin/qubes-gui-runuser
@@ -130,6 +130,8 @@
 		$(DESTDIR)/usr/bin/qubes-run-xephyr
 	install -D appvm-scripts/usrbin/qubes-start-xephyr \
 		$(DESTDIR)/usr/bin/qubes-start-xephyr
+	install -D appvm-scripts/usrbin/qubes-run-x11vnc \
+		$(DESTDIR)/usr/bin/qubes-run-x11vnc
 	install -D appvm-scripts/usrbin/qubes-change-keyboard-layout \
 		$(DESTDIR)/usr/bin/qubes-change-keyboard-layout
 	install -D appvm-scripts/usrbin/qubes-set-monitor-layout \
@@ -142,6 +144,10 @@
 		$(DESTDIR)$(LIBDIR)/xorg/modules/drivers/dummyqbs_drv.so
 	install -m 0644 -D appvm-scripts/etc/X11/xorg-qubes.conf.template \
 		$(DESTDIR)/etc/X11/xorg-qubes.conf.template
+	install -m 0644 -D appvm-scripts/etc/X11/xorg-qubes-x11vnc.conf.template \
+		$(DESTDIR)/etc/X11/xorg-qubes-x11vnc.conf.template
+	install -m 0644 -D appvm-scripts/etc/systemd/system/lightdm.service.d/qubes-guivm-vnc.conf \
+		$(DESTDIR)/etc/systemd/system/lightdm.service.d/qubes-guivm-vnc.conf
 	install -m 0644 -D appvm-scripts/etc/profile.d/qubes-gui.sh \
 		$(DESTDIR)/etc/profile.d/qubes-gui.sh
 	install -m 0644 -D appvm-scripts/etc/profile.d/qubes-gui.csh \

=== debian/changelog ===
qubes-gui-agent (4.1.19-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Thu, 01 Jul 2021 05:45:06 +0200

qubes-gui-agent (4.1.19-1) unstable; urgency=medium

  [ Frédéric Pierret (fepitre) ]
  * Implement VNC GuiVM
  * guivm-vnc: use /run directly in lightdm preset conf
  * guivm-vnc: simplify options set
  * guivm-vnc: add few comments for pre script
  * Use only one script for pre and post
  * spec: remove xorg-x11-utils and replace by dependencies

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Thu, 01 Jul 2021 05:45:06 +0200

## qubes-gui-agent 4.1.20

=== debian/changelog ===
qubes-gui-agent (4.1.20-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Fri, 09 Jul 2021 05:02:15 +0200

qubes-gui-agent (4.1.20-1) unstable; urgency=medium

  [ Demi Marie Obenour ]
  * Remove the last XInternAtom call after startup
  * Use ternary operator to simplify some code
  * Failure to intern MANAGER atom is fatal
  * Crash if snprintf() fails
  * Use XInternAtoms() more

  [ Marek Marczykowski-Górecki ]
  * Fix tray message opcode
  * Fix getting all the required atoms

  [ Demi Marie Obenour ]
  * Fix the name of WM_DELETE_WINDOW

  [ Marek Marczykowski-Górecki ]
  * rpm: add xrandr dependency

  [ Ivan Kardykov ]
  * Always keep latin keyboard layout

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 09 Jul 2021 05:02:15 +0200

## qubes-gui-agent 4.1.21

=== debian/changelog ===
qubes-gui-agent (4.1.21-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Sat, 10 Jul 2021 13:54:45 +0200

qubes-gui-agent (4.1.21-1) unstable; urgency=medium

  [ Nedyalko Andreev ]
  * Fix support for non-latin variants when we append the us layout

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sat, 10 Jul 2021 13:54:45 +0200

=== debian/control ===
Source: qubes-gui-agent
Section: admin
Priority: extra
Maintainer: Davíð Steinn Geirsson <david@dsg.is>
Build-Depends:
    debhelper,
    libpam0g-dev,
    libpulse-dev,
    libtool,
    automake,
    xserver-xorg-dev,
    xutils-dev,
    libvchan-dev,
    libx11-dev,
    libxcomposite-dev,
    libxdamage-dev,
    libxfixes-dev,
    x11proto-xf86dga-dev,
    libxt-dev,
    libxen-dev,
    lsb-release,
    quilt,
    qubes-gui-common (>= 4.1.0),
    qubesdb-dev,
    libltdl-dev
Standards-Version: 4.4.0.1
Homepage: http://www.qubes-os.org/
#Vcs-Git: git://git.debian.org/collab-maint/qubes-gui-agent.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/qubes-gui-agent.git;a=summary

Package: qubes-gui-agent
Architecture: any
Depends:
    xserver-xorg-core,
    xinit,
    x11-xserver-utils,
    qubes-core-agent (>= 3.0.14),
    qubesdb-vm (>= 4.1.4),
    libxdamage1,
    libxcomposite1,
    libxfixes3,
    libxt6,
    libx11-6,
    python3,
    python3-xcffib,
    xserver-xorg-video-dummyqbs (= ${binary:Version}),
    xserver-xorg-input-qubes (= ${binary:Version}),
    ${shlibs:Depends},
    ${misc:Depends}
Recommends: qt4-qtconfig, pulseaudio-qubes
Provides: x-display-manager
Description: Makes X11 windows available to qubes dom0
 The Qubes GUI agent allows the forwarding of running app windows to the
 qubes dom0. It also includes various extras such as copy/paste support.

Package: xserver-xorg-qubes-common
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Common functions for qubes xserver driver
 Shared library which contains common functions of the Qubes xserver drivers.

Package: xserver-xorg-video-dummyqbs
Architecture: any
Depends:
 ${xviddriver:Depends},
 ${shlibs:Depends},
 ${misc:Depends},
 xserver-xorg-qubes-common (= ${binary:Version})
Provides:
 ${xviddriver:Provides}
Replaces: qubes-gui-agent (<< 3.2.11-1)
Breaks: qubes-gui-agent (<< 3.2.11-1)
Description: Dummy X video driver for qubes-gui-agent
 Dummy X video driver for Qubes VM, with XRandr support.

Package: xserver-xorg-input-qubes
Architecture: any
Depends:
 ${xinpdriver:Depends},
 ${shlibs:Depends},
 ${misc:Depends},
 xserver-xorg-qubes-common (= ${binary:Version})
Provides:
 ${xinpdriver:Provides}
Replaces: qubes-gui-agent (<< 3.2.11-1)
Breaks: qubes-gui-agent (<< 3.2.11-1)
Description: X input driver for injecting events from qubes-gui-agent
 This driver inject input events delivered through qubes-gui-agent.
 Additionally it helps retrieving composition buffers of windows.

Package: pulseaudio-qubes
Architecture: any
Depends:
    qubesdb-vm (>= 4.1.4),
    pulseaudio,
    libpulse0,
    ${shlibs:Depends},
    ${pulse:Depends},
    ${misc:Depends}
Replaces: qubes-gui-agent (<< 4.1.9-1)
Breaks: qubes-gui-agent (<< 4.1.9-1)
Description: Audio support for Qubes VM
 Pulseaudio module to enable sound support in Qubes VM

Package: qubes-gui-agent-xfce
Architecture: any
Depends:
    ${shlibs:Depends},
    ${misc:Depends}
Description: XFCE desktop support for Qubes VM
 XFCE desktop support for Qubes VM

Package: qubes-gui-vnc
Architecture: any
Depends:
    x11vnc
    ${shlibs:Depends},
    ${misc:Depends}
Description: Remote GuiVM support using VNC
 Remote GuiVM support using VNC

## qubes-gui-agent 4.1.22

=== debian/changelog ===
qubes-gui-agent (4.1.22-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Tue, 24 Aug 2021 03:56:41 +0200

qubes-gui-agent (4.1.22-1) unstable; urgency=medium

  [ fepitre-bot ]
  * Add pulseaudio-15.0 headers

  [ Marek Marczykowski-Górecki ]
  * pulse: set module version to the PA version

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 24 Aug 2021 03:56:41 +0200

## qubes-gui-agent 4.1.23

=== debian/changelog ===
qubes-gui-agent (4.1.23-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Tue, 09 Nov 2021 05:31:28 +0100

qubes-gui-agent (4.1.23-1) unstable; urgency=medium

  [ Demi Marie Obenour ]
  * Ensure that no subwindows are created
  * Fix minor problems

  [ Marek Marczykowski-Górecki ]
  * Fix XEMBED_EMBEDDED_NOTIFY parameters

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 09 Nov 2021 05:31:28 +0100

## qubes-gui-agent 4.1.24

=== debian/changelog ===
qubes-gui-agent (4.1.24-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Thu, 06 Jan 2022 04:41:12 +0100

qubes-gui-agent (4.1.24-1) unstable; urgency=medium

  * archlinux: bump xorg ABI version requirements

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Thu, 06 Jan 2022 04:41:12 +0100

## qubes-gui-agent 4.1.25

=== debian/changelog ===
qubes-gui-agent (4.1.25-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Sat, 05 Mar 2022 06:06:57 +0100

qubes-gui-agent (4.1.25-1) unstable; urgency=medium

  [ Otto Sabart ]
  * archlinux: add lsb-release into make dependencies

  [ Rudd-O ]
  * Make qubes-session inherit the systemd user session variables.
  * Update qubes-session

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sat, 05 Mar 2022 06:06:57 +0100

## qubes-gui-agent 4.1.26

=== Makefile ===
--- 
+++ 
@@ -26,6 +26,8 @@
 DATADIR ?= /usr/share
 PA_VER_FULL ?= $(shell pkg-config --modversion libpulse | cut -d "-" -f 1 || echo 0.0)
 PA_VER_MAJOR_MINOR ?= $(shell echo $(PA_VER_FULL) | cut -d "." -f 1,2)
+PA_VER_MAJOR ?= $(shell echo $(PA_VER_MAJOR_MINOR) | cut -d "." -f 1)
+PA_MODULE_DIR ?= $(shell if [ $(PA_VER_MAJOR) -ge 16 ]; then echo pulseaudio; else if [ "$(lsb_release -is)" != "Ubuntu" ]; then echo pulse-$(PA_VER_MAJOR_MINOR); else pulse-$(PA_VER_FULL); fi; fi)
 
 help:
 	@echo "Qubes GUI main Makefile:" ;\
@@ -100,13 +102,8 @@
 		$(DESTDIR)/usr/bin/start-pulseaudio-with-vchan
 	install -m 0644 -D pulse/qubes-default.pa \
 		$(DESTDIR)/etc/pulse/qubes-default.pa
-ifneq ($(shell lsb_release -is), Ubuntu)
 	install -D pulse/module-vchan-sink.so \
-		$(DESTDIR)$(LIBDIR)/pulse-$(PA_VER_MAJOR_MINOR)/modules/module-vchan-sink.so
-else
-	install -D pulse/module-vchan-sink.so \
-		$(DESTDIR)$(LIBDIR)/pulse-$(PA_VER_FULL)/modules/module-vchan-sink.so
-endif
+		$(DESTDIR)$(LIBDIR)/$(PA_MODULE_DIR)/modules/module-vchan-sink.so
 	install -m 0644 -D appvm-scripts/etc/tmpfiles.d/qubes-pulseaudio.conf \
 		$(DESTDIR)/$(USRLIBDIR)/tmpfiles.d/qubes-pulseaudio.conf
 	install -m 0644 -D appvm-scripts/etc/xdgautostart/qubes-pulseaudio.desktop \

=== debian/changelog ===
qubes-gui-agent (4.1.26-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Thu, 23 Jun 2022 00:24:25 +0200

qubes-gui-agent (4.1.26-1) unstable; urgency=medium

  [ Frédéric Pierret (fepitre) ]
  * Drop Travis CI

  [ ejose19 ]
  * adjust pulsecore download script to use upstream repo to obtain
    headers
  * Adjust pulseaudio modules dir

  [ Frédéric Pierret (fepitre) ]
  * get-latest-pulsecore.sh: ensure to use gpg for git tag

  [ fepitre-bot ]
  * Add pulseaudio-16.1 headers

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Thu, 23 Jun 2022 00:24:25 +0200

## qubes-gui-agent 4.1.27

=== debian/changelog ===
qubes-gui-agent (4.1.27-1+deb12u1) bookworm; urgency=medium

  * Build for bookworm

 -- Builder <user@localhost>  Thu, 20 Oct 2022 02:05:33 +0200

qubes-gui-agent (4.1.27-1) unstable; urgency=medium

  [ Frédéric Pierret (fepitre) ]
  * Add Qubes Builder v2 integration
  * .qubesbuilder: replace 'spec' by 'build'

  [ Demi Marie Obenour ]
  * Use larger vchan buffers
  * Drop obsolete checks for disposable VM restore

  [ Marek Marczykowski-Górecki ]
  * rpm: fix pulseaudio version detection
  * Fix pulseaudio module path

  [ Demi Marie Obenour ]
  * Remove hanging person image

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Thu, 20 Oct 2022 02:05:33 +0200

## qubes-gui-agent 4.1.28

=== Makefile ===
--- 
+++ 
@@ -25,9 +25,7 @@
 SYSLIBDIR ?= /lib
 DATADIR ?= /usr/share
 PA_VER_FULL ?= $(shell pkg-config --modversion libpulse | cut -d "-" -f 1 || echo 0.0)
-PA_VER_MAJOR_MINOR ?= $(shell echo $(PA_VER_FULL) | cut -d "." -f 1,2)
-PA_VER_MAJOR ?= $(shell echo $(PA_VER_MAJOR_MINOR) | cut -d "." -f 1)
-PA_MODULE_DIR ?= $(shell if [ $(PA_VER_MAJOR) -ge 16 ]; then echo pulseaudio; else if [ "$(lsb_release -is)" != "Ubuntu" ]; then echo pulse-$(PA_VER_MAJOR_MINOR); else pulse-$(PA_VER_FULL); fi; fi)
+PA_MODULE_DIR ?= $(shell pkg-config --variable=modlibexecdir libpulse)
 
 help:
 	@echo "Qubes GUI main Makefile:" ;\
@@ -103,7 +101,7 @@
 	install -m 0644 -D pulse/qubes-default.pa \
 		$(DESTDIR)/etc/pulse/qubes-default.pa
 	install -D pulse/module-vchan-sink.so \
-		$(DESTDIR)$(LIBDIR)/$(PA_MODULE_DIR)/modules/module-vchan-sink.so
+		$(DESTDIR)$(PA_MODULE_DIR)/module-vchan-sink.so
 	install -m 0644 -D appvm-scripts/etc/tmpfiles.d/qubes-pulseaudio.conf \
 		$(DESTDIR)/$(USRLIBDIR)/tmpfiles.d/qubes-pulseaudio.conf
 	install -m 0644 -D appvm-scripts/etc/xdgautostart/qubes-pulseaudio.desktop \

=== pulse/Makefile ===
CC=gcc
CFLAGS+=-Wall -Wextra -Werror -O2
LIBS=-lqubesdb
VCHANLIBS=`pkg-config --libs vchan`
VCHANCFLAGS=`pkg-config --cflags vchan`
GLIBCFLAGS=`pkg-config --cflags glib-2.0` `pkg-config --cflags dbus-glib-1`
GLIBLIBS=`pkg-config --libs glib-2.0` `pkg-config --libs dbus-glib-1` `pkg-config --libs gthread-2.0`
all: module-vchan-sink.so
module-vchan-sink.so: module-vchan-sink.o
	$(CC) -shared -o module-vchan-sink.so module-vchan-sink.o \
		$(VCHANLIBS) $(LIBS)
module-vchan-sink.o: module-vchan-sink.c
	$(CC) $(CFLAGS) -g -c $(VCHANCFLAGS) -fPIC module-vchan-sink.c  -DHAVE_CONFIG_H -DHAVE_QUBESDB_CLIENT_H -I.
clean:
	rm -f *.so *.o *~

=== debian/changelog ===
qubes-gui-agent (4.1.28-1+deb12u1) bookworm; urgency=medium

  * Build for bookworm

 -- Builder <user@localhost>  Mon, 05 Dec 2022 15:36:29 +0100

qubes-gui-agent (4.1.28-1) unstable; urgency=medium

  [ Ivan Kardykov ]
  * dummyqbs: Add glamor acceleration
  * dummyqbs: fix debian build with glamor

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Mon, 05 Dec 2022 15:36:29 +0100

## qubes-gui-agent 4.2.0

=== Makefile ===
--- 
+++ 
@@ -26,6 +26,8 @@
 DATADIR ?= /usr/share
 PA_VER_FULL ?= $(shell pkg-config --modversion libpulse | cut -d "-" -f 1 || echo 0.0)
 PA_MODULE_DIR ?= $(shell pkg-config --variable=modlibexecdir libpulse)
+
+USER_DROPIN_DIR ?= /usr/lib/systemd/user
 
 help:
 	@echo "Qubes GUI main Makefile:" ;\
@@ -106,6 +108,11 @@
 		$(DESTDIR)/$(USRLIBDIR)/tmpfiles.d/qubes-pulseaudio.conf
 	install -m 0644 -D appvm-scripts/etc/xdgautostart/qubes-pulseaudio.desktop \
 		$(DESTDIR)/etc/xdg/autostart/qubes-pulseaudio.desktop
+	install -d $(DESTDIR)$(USER_DROPIN_DIR)/pulseaudio.service.d
+	install -m 0644 pulse/pulseaudio.service.d/*.conf \
+		$(DESTDIR)$(USER_DROPIN_DIR)/pulseaudio.service.d
+	install -D pulse/75-pulseaudio-qubes.preset \
+		$(DESTDIR)$(USER_DROPIN_DIR)-preset/75-pulseaudio-qubes.preset
 
 install-systemd:
 	install -m 0644 -D appvm-scripts/qubes-gui-agent.service \

=== debian/changelog ===
qubes-gui-agent (4.2.0-1+deb12u1) bookworm; urgency=medium

  * Build for bookworm

 -- Builder <user@localhost>  Thu, 29 Dec 2022 04:16:09 +0100

qubes-gui-agent (4.2.0-1) unstable; urgency=medium

  [ Mateusz Piórkowski ]
  * Add automatic clipboard wipe
  * Make clipboard wipe togglable
  * Change the clipboard wipe service name to `gui-agent-clipboard-wipe`
  * Announce support for the clipboard wipe service

  [ Demi Marie Obenour ]
  * Let systemd manage PulseAudio

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Thu, 29 Dec 2022 04:16:09 +0100

## qubes-gui-agent 4.2.1

=== debian/changelog ===
qubes-gui-agent (4.2.1-1+deb12u1) bookworm; urgency=medium

  * Build for bookworm

 -- Builder <user@localhost>  Fri, 30 Dec 2022 08:43:40 +0100

qubes-gui-agent (4.2.1-1) unstable; urgency=medium

  [ Demi Marie Obenour ]
  * SELinux support
  * Require pam_selinux and pam_loginuid if they exist
  * Move SELinux to a new spec file
  * Makefile improvements

  [ Marek Marczykowski-Górecki ]
  * Add gui-agent-vm spec to .qubesbuilder too
  * ci: drop R4.1

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 30 Dec 2022 08:43:40 +0100

## qubes-gui-agent 4.2.2

=== debian/changelog ===
qubes-gui-agent (4.2.2-1+deb12u1) bookworm; urgency=medium

  * Build for bookworm

 -- Builder <user@localhost>  Mon, 09 Jan 2023 12:55:12 +0100

qubes-gui-agent (4.2.2-1) unstable; urgency=medium

  * rpm: remove explicit dependency on libvchan

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Mon, 09 Jan 2023 12:55:12 +0100

## qubes-gui-agent 4.2.3

=== debian/changelog ===
qubes-gui-agent (4.2.3-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Fri, 14 Apr 2023 04:17:31 +0200

qubes-gui-agent (4.2.3-1) unstable; urgency=medium

  [ noskb ]
  * Remove duplicated button from titlebar of gnome applications

  [ Marek Marczykowski-Górecki ]
  * Workaround software rendering issues in GTK4
  * Do not exit from qubes-run-xorg after starting Xorg

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 14 Apr 2023 04:17:31 +0200

=== debian/control ===
--- 
+++ 
@@ -12,6 +12,7 @@
     xutils-dev,
     libvchan-dev,
     libx11-dev,
+    libgbm-dev,
     libxcomposite-dev,
     libxdamage-dev,
     libxfixes-dev,
@@ -98,9 +99,13 @@
     libpulse0,
     ${shlibs:Depends},
     ${pulse:Depends},
-    ${misc:Depends}
-Replaces: qubes-gui-agent (<< 4.1.9-1)
-Breaks: qubes-gui-agent (<< 4.1.9-1)
+    ${misc:Depends},
+Replaces:
+ qubes-gui-agent (<< 4.1.9-1),
+ qubes-core-agent (<< 4.2.5-1),
+Breaks:
+ qubes-gui-agent (<< 4.1.9-1),
+ qubes-core-agent (<< 4.2.5-1),
 Description: Audio support for Qubes VM
  Pulseaudio module to enable sound support in Qubes VM

## qubes-gui-agent 4.2.4

=== debian/changelog ===
qubes-gui-agent (4.2.4-1+deb12u1) bookworm; urgency=medium

  * Build for bookworm

 -- Builder <user@localhost>  Wed, 26 Apr 2023 14:45:39 +0200

qubes-gui-agent (4.2.4-1) unstable; urgency=medium

  [ Frédéric Pierret (fepitre) ]
  * Rework Archlinux packaging

  [ Marek Marczykowski-Górecki ]
  * Add pulse 15.99.1 headers for jammy build

  [ Demi Marie Obenour ]
  * PipeWire audio support for Qubes OS
  * Clean up the Arch PKGBUILD
  * Use proper RPM macros for paths
  * Avoid a deprecated use of dh_install
  * Add RPM post-install and pre-uninstall scriptlets
  * Add Debian postinstall script
  * Add Arch post-install scripts
  * Raise priority of PipeWire preset files
  * Try to fix linker errors
  * Shrink quantum to reduce latency
  * Implement reconnection and fix bugs
  * Fix requested size calculation
  * Avoid blocking realtime thread
  * Avoid potential race conditions and use-after-free
  * Recover from temporary overruns
  * Reduce excessive log verbosity
  * Always dequeue at least one buffer
  * Record silence during underruns
  * Fix race between PipeWire and this module
  * Handle playback to a seemingly-paused stream
  * Prevent NULL pointer dereference on disconnect
  * Make playback and record buffers tunable
  * Obtain PipeWire resources before parsing config
  * Implement format negotiation for the capture stream
  * Fix build on old PipeWire versions
  * Replace assert() with spa_assert()
  * Provide buffer information to pw_stream_update_params()
  * Fix segfault on startup
  * Fix manual configuration of buffer sizes
  * Document how to change buffer sizes
  * Use the standard Makefile name
  * Avoid abusing EFAULT
  * Remove pointless _Static_assert()
  * Add some documentation
  * Remove useless forward declarations
  * Use common function to stop watching for vchan events
  * Stop watching the vchan during shutdown
  * Fix comment
  * Set the correct vchan to NULL
  * Remove some useless code
  * Ensure all control commands are sent eventually
  * Reduce logging verbosity
  * Remove wrong assert
  * Use less strict number parsing
  * Packaging fixups
  * Distribute license text with package
  * Try to handle configuration overrides
  * Fix build with old PipeWire
  * Ensure that assertions are enabled
  * Update usage information
  * Shorten the name of the module
  * Report stream states on vchan connect
  * Do not rely on asserts for error handling
  * Only use pw_log_error() for true errors
  * Do not disable streams if control vchan is closed
  * Sync stream states after vchan open
  * Process control commands if an overrun occurs
  * Provide default buffer sizes
  * Use common code for stream shutdown
  * Remove shutting_down global variable
  * Shut down dead streams
  * Fix NULL pointer dereference if vchan connection fails
  * Use a smaller SPA builder buffer
  * Assert that SPA builder succeeded
  * Debian packaging fixups
  * Use (C) instead of © in COPYING
  * Allow domain IDs up to INT_MAX/2
  * Avoid using bitfields
  * Check that atomics are lock-free
  * Turn off PulseAudio if PipeWire is enabled
  * Advertise the PipeWire service to dom0
  * Fix 'make install'
  * PipeWire agent: Add dependency on PipeWire
  * PipeWire agent is not less code

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Wed, 26 Apr 2023 14:45:39 +0200

=== debian/control ===
--- 
+++ 
@@ -20,10 +20,11 @@
     libxt-dev,
     libxen-dev,
     lsb-release,
+    libpipewire-0.3-dev,
     quilt,
     qubes-gui-common (>= 4.1.0),
     qubesdb-dev,
-    libltdl-dev
+    libltdl-dev,
 Standards-Version: 4.4.0.1
 Homepage: http://www.qubes-os.org/
 #Vcs-Git: git://git.debian.org/collab-maint/qubes-gui-agent.git
@@ -109,6 +110,18 @@
 Description: Audio support for Qubes VM
  Pulseaudio module to enable sound support in Qubes VM
 
+Package: pipewire-qubes
+Architecture: any
+Depends:
+ qubesdb-vm (>= 4.1.4),
+ ${shlibs:Depends},
+ ${misc:Depends}
+Description: PipeWire module to enable sound support in Qubes VM
+ Experimental PipeWire module to enable sound support in Qubes VMs.
+ Unlike the PulseAudio support in the pulseaudio-qubes package, this
+ works with the stock PipeWire service and does not depend on internal
+ PipeWire headers.  It is also less code.
+
 Package: qubes-gui-agent-xfce
 Architecture: any
 Depends:

=== debian/rules ===
--- 
+++ 
@@ -23,10 +23,16 @@
 	make install-debian
 
 override_dh_systemd_start:
-	dh_systemd_start --no-restart-on-upgrade
+	dh_systemd_start --no-restart-after-upgrade --no-restart-on-upgrade
 
 override_dh_install:
-	dh_install --fail-missing
+	dh_install
+
+override_dh_missing:
+	dh_missing --fail-missing
+
+override_dh_installsystemduser:
+	dh_installsystemduser pipewire.socket pipewire-pulse.socket pipewire.service pipewire-pulse.service wireplumber.service
 
 override_dh_gencontrol:
 	echo "pulse:Depends=pulseaudio (>= $(PA_VER)), pulseaudio (<< $(PA_VER).1)" >> debian/pulseaudio-qubes.substvars

## qubes-gui-agent 4.2.5

=== debian/changelog ===
qubes-gui-agent (4.2.5-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Sun, 07 May 2023 16:33:59 +0200

qubes-gui-agent (4.2.5-1) unstable; urgency=medium

  [ Frédéric Pierret (fepitre) ]
  * Add support for Ubuntu in builderv2
  * .qubesbuilder: fix sed for ubuntu

  [ Marek Marczykowski-Górecki ]
  * pulse: use pulseaudio version from pkg-config

  [ Frédéric Pierret (fepitre) ]
  * jammy: use pipewire

  [ Marek Marczykowski-Górecki ]
  * Fix setting pipewire-qubes as recommended under Ubuntu jammy

  [ Frédéric Pierret (fepitre) ]
  * pipewire-qubes: add pipewire-pulse dependency
  * debian: enable pipewire starting from bookworm
  * debian: update maintainer
  * debian: move piprewire-pulse in Recommends

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sun, 07 May 2023 16:33:59 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: qubes-gui-agent
 Section: admin
 Priority: extra
-Maintainer: Davíð Steinn Geirsson <david@dsg.is>
+Maintainer: Qubes OS Team <qubes-devel@googlegroups.com>
 Build-Depends:
     debhelper,
     libpam0g-dev,
@@ -49,7 +49,7 @@
     xserver-xorg-input-qubes (= ${binary:Version}),
     ${shlibs:Depends},
     ${misc:Depends}
-Recommends: qt4-qtconfig, pulseaudio-qubes
+Recommends: qt4-qtconfig, pipewire-qubes
 Provides: x-display-manager
 Description: Makes X11 windows available to qubes dom0
  The Qubes GUI agent allows the forwarding of running app windows to the
@@ -116,6 +116,7 @@
  qubesdb-vm (>= 4.1.4),
  ${shlibs:Depends},
  ${misc:Depends}
+Recommends: pipewire-pulse
 Description: PipeWire module to enable sound support in Qubes VM
  Experimental PipeWire module to enable sound support in Qubes VMs.
  Unlike the PulseAudio support in the pulseaudio-qubes package, this

## qubes-gui-agent 4.2.6

=== Makefile ===
--- 
+++ 
@@ -19,26 +19,44 @@
 #
 #
 
-VERSION := $(shell cat version)
+VERSION := $(file <version)
 LIBDIR ?= /usr/lib64
 USRLIBDIR ?= /usr/lib
 SYSLIBDIR ?= /lib
+UNITDIR ?= $(SYSLIBDIR)/systemd/system
+USERUNITDIR ?= $(SYSLIBDIR)/systemd/user
+USERPRESETDIR ?= $(SYSLIBDIR)/systemd/user-preset
+UDEVRULESDIR ?= $(SYSLIBDIR)/udev/rules.d
 DATADIR ?= /usr/share
+PIPEWIRE_MODULES ?= $(LIBDIR)/pipewire-0.3
+ifneq (,$(filter-out selinux install-selinux,$(MAKECMDGOALS)))
 PA_VER_FULL ?= $(shell pkg-config --modversion libpulse | cut -d "-" -f 1 || echo 0.0)
 PA_MODULE_DIR ?= $(shell pkg-config --variable=modlibexecdir libpulse)
+endif
 
 USER_DROPIN_DIR ?= /usr/lib/systemd/user
 
+.PHONY: help
 help:
 	@echo "Qubes GUI main Makefile:" ;\
 	    echo; \
 	    echo "make clean                <--- clean all the binary files";\
-	    @exit 0;
-
+	    exit 0;
+
+.PHONY: appvm
 appvm: gui-agent/qubes-gui gui-common/qubes-gui-runuser \
 	xf86-input-mfndev/src/.libs/qubes_drv.so \
 	xf86-video-dummy/src/.libs/dummyqbs_drv.so pulse/module-vchan-sink.so \
-	xf86-qubes-common/libxf86-qubes-common.so
+	xf86-qubes-common/libxf86-qubes-common.so pipewire/qubes-pw-module.so
+
+selinux_policies ::= qubes-gui-agent.pp
+selinux: selinux/$(selinux_policies)
+selinux/$(selinux_policies):
+	$(MAKE) -C selinux -f /usr/share/selinux/devel/Makefile
+
+.PHONY: install-selinux
+install-selinux:
+	install -D -t $(DESTDIR)/usr/share/selinux/packages selinux/$(selinux_policies)
 
 gui-agent/qubes-gui:
 	$(MAKE) -C gui-agent
@@ -56,15 +74,20 @@
 
 pulse/module-vchan-sink.so:
 	rm -f pulse/pulsecore
-	ln -s pulsecore-$(PA_VER_FULL) pulse/pulsecore
+	ln -sf pulsecore-$(PA_VER_FULL) pulse/pulsecore
 	$(MAKE) -C pulse module-vchan-sink.so
+
+pipewire/qubes-pw-module.so:
+	$(MAKE) -C pipewire qubes-pw-module.so
 
 xf86-qubes-common/libxf86-qubes-common.so:
 	$(MAKE) -C xf86-qubes-common libxf86-qubes-common.so
 
+.PHONY: tar
 tar:
 	git archive --format=tar --prefix=qubes-gui/ HEAD -o qubes-gui.tar
 
+.PHONY: clean
 clean:
 	(cd common && $(MAKE) clean)
 	(cd gui-agent && $(MAKE) clean)
@@ -76,9 +99,10 @@
 	rm -rf debian/changelog.*
 	rm -rf pkgs
 
-
-install: install-rh-agent install-pulseaudio
-
+.PHONY: install
+install: install-rh-agent install-pulseaudio install-pipewire
+
+.PHONY: install-rh-agent
 install-rh-agent: appvm install-common install-systemd
 	install -m 0644 -D appvm-scripts/etc/sysconfig/desktop \
 		$(DESTDIR)/etc/sysconfig/desktop
@@ -91,12 +115,14 @@
 	install -D appvm-scripts/etc/X11/xinit/xinitrc.d/60xfce-desktop.sh \
 		$(DESTDIR)/etc/X11/xinit/xinitrc.d/60xfce-desktop.sh
 
-install-debian: appvm install-common install-pulseaudio install-systemd
+.PHONY: install-debian
+install-debian: appvm install-common install-pulseaudio install-systemd install-pipewire
 	install -d $(DESTDIR)/etc/X11/Xsession.d
 	install -m 0644 appvm-scripts/etc/X11/Xsession.d/* $(DESTDIR)/etc/X11/Xsession.d/
 	install -d $(DESTDIR)/etc/xdg
 	install -m 0644 appvm-scripts/etc/xdg-debian/* $(DESTDIR)/etc/xdg
 
+.PHONY: install-pulseaudio
 install-pulseaudio:
 	install -D pulse/start-pulseaudio-with-vchan \
 		$(DESTDIR)/usr/bin/start-pulseaudio-with-vchan
@@ -105,7 +131,7 @@
 	install -D pulse/module-vchan-sink.so \
 		$(DESTDIR)$(PA_MODULE_DIR)/module-vchan-sink.so
 	install -m 0644 -D appvm-scripts/etc/tmpfiles.d/qubes-pulseaudio.conf \
-		$(DESTDIR)/$(USRLIBDIR)/tmpfiles.d/qubes-pulseaudio.conf
+		$(DESTDIR)$(USRLIBDIR)/tmpfiles.d/qubes-pulseaudio.conf
 	install -m 0644 -D appvm-scripts/etc/xdgautostart/qubes-pulseaudio.desktop \
 		$(DESTDIR)/etc/xdg/autostart/qubes-pulseaudio.desktop
 	install -d $(DESTDIR)$(USER_DROPIN_DIR)/pulseaudio.service.d
@@ -114,10 +140,26 @@
 	install -D pulse/75-pulseaudio-qubes.preset \
 		$(DESTDIR)$(USER_DROPIN_DIR)-preset/75-pulseaudio-qubes.preset
 
+.PHONY: install-pipewire
+install-pipewire:
+	install -m 0755 -D pipewire/qubes-pw-module.so \
+		$(DESTDIR)$(PIPEWIRE_MODULES)/libpipewire-module-qubes.so
+	install -m 0644 -D pipewire/30_qubes.conf \
+		$(DESTDIR)$(DATADIR)/pipewire/pipewire.conf.d/30_qubes.conf
+	install -m 0644 -D pipewire/COPYING \
+		$(DESTDIR)$(DATADIR)/licenses/pipewire-qubes/COPYING
+	install -m 0644 -D appvm-scripts/lib/systemd/user-preset/74-qubes-vm.preset \
+		$(DESTDIR)$(USERPRESETDIR)/74-qubes-vm.preset
+	install -d $(DESTDIR)/etc/qubes/post-install.d
+	install -m 0755 appvm-scripts/etc/qubes/post-install.d/20-qubes-pipewire.sh \
+                $(DESTDIR)/etc/qubes/post-install.d/20-qubes-pipewire.sh
+
+.PHONY: install-systemd
 install-systemd:
 	install -m 0644 -D appvm-scripts/qubes-gui-agent.service \
-		$(DESTDIR)/$(SYSLIBDIR)/systemd/system/qubes-gui-agent.service
-
+		$(DESTDIR)$(UNITDIR)/qubes-gui-agent.service
+
+.PHONY: install-common
 install-common:
 	install -D gui-agent/qubes-gui $(DESTDIR)/usr/bin/qubes-gui
 	install -D gui-common/qubes-gui-runuser $(DESTDIR)/usr/bin/qubes-gui-runuser
@@ -163,9 +205,9 @@
 	install -m 0644 -D appvm-scripts/qubes-gui-vm.gschema.override \
 		$(DESTDIR)$(DATADIR)/glib-2.0/schemas/20_qubes-gui-vm.gschema.override
 	install -d $(DESTDIR)/etc/qubes-rpc
-	ln -s ../../usr/bin/qubes-set-monitor-layout \
+	ln -sf ../../usr/bin/qubes-set-monitor-layout \
 		$(DESTDIR)/etc/qubes-rpc/qubes.SetMonitorLayout
-	ln -s ../../usr/bin/qubes-start-xephyr \
+	ln -sf ../../usr/bin/qubes-start-xephyr \
 		$(DESTDIR)/etc/qubes-rpc/qubes.GuiVMSession
 	install -D window-icon-updater/icon-sender \
 		$(DESTDIR)/usr/lib/qubes/icon-sender
@@ -175,14 +217,20 @@
 		$(DESTDIR)/etc/xdg/autostart/qubes-qrexec-fork-server.desktop
 	install -m 0644 -D appvm-scripts/etc/xdgautostart/qubes-keymap.desktop \
 		$(DESTDIR)/etc/xdg/autostart/qubes-keymap.desktop
+	install -m 0644 -D appvm-scripts/etc/xdgautostart/qubes-gtk4-workarounds.desktop \
+		$(DESTDIR)/etc/xdg/autostart/qubes-gtk4-workarounds.desktop
 	install -D -m 0644 appvm-scripts/usr/lib/sysctl.d/30-qubes-gui-agent.conf \
 		$(DESTDIR)/usr/lib/sysctl.d/30-qubes-gui-agent.conf
 	install -D -m 0644 appvm-scripts/lib/udev/rules.d/70-master-of-seat.rules \
-		$(DESTDIR)/$(SYSLIBDIR)/udev/rules.d/70-master-of-seat.rules
+		$(DESTDIR)/$(UDEVRULESDIR)/70-master-of-seat.rules
 	install -D appvm-scripts/usr/lib/qubes/qubes-gui-agent-pre.sh \
 		$(DESTDIR)/usr/lib/qubes/qubes-gui-agent-pre.sh
 	install -D appvm-scripts/usr/lib/qubes/qubes-keymap.sh \
 		$(DESTDIR)/usr/lib/qubes/qubes-keymap.sh
+	install -D appvm-scripts/usr/lib/qubes/qubes-xorg-wrapper \
+		$(DESTDIR)/usr/lib/qubes/qubes-xorg-wrapper
+	install -D appvm-scripts/usr/lib/qubes/gtk4-workarounds.sh \
+		$(DESTDIR)/usr/lib/qubes/gtk4-workarounds.sh
 ifeq ($(shell lsb_release -is), Debian)
 	install -D -m 0644 appvm-scripts/etc/pam.d/qubes-gui-agent.debian \
 		$(DESTDIR)/etc/pam.d/qubes-gui-agent

=== pipewire/Makefile ===
extra_cflags := $(shell pkg-config --cflags libpipewire-0.3 vchan-xen) \
  -fno-strict-aliasing -fno-strict-overflow \
  -fno-delete-null-pointer-checks -fPIC -Wall -Wextra -Werror \
  -Wno-missing-field-initializers -Wno-unused-parameter -ggdb -O2 \
  -D_FORTIFY_SOURCE=2
extra_ldflags :=  $(shell pkg-config --libs libpipewire-0.3 vchan-xen) -lqubesdb
CFLAGS += $(extra_cflags)
LDLIBS += $(extra_ldflags)
LDFLAGS += -ggdb -Wl,--no-as-needed,--no-allow-shlib-undefined,-z,relro,-z,now
qubes-pw-module.so: build/qubes-pw-module.o | Makefile
	@mkdir -p -m 0700 -- build
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ -shared $(LDLIBS)

build/%.o: %.c Makefile
	@mkdir -p -m 0700 -- build
	$(CC) $(CPPFLAGS) $(CFLAGS) -c -o $@ $< -MP -MD -MF $@.dep

.PHONY: clean
clean:
	rm -rf -- build
-include build/*.o.dep

=== debian/changelog ===
qubes-gui-agent (4.2.6-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Tue, 16 May 2023 04:23:02 +0200

qubes-gui-agent (4.2.6-1) unstable; urgency=medium

  [ Frédéric Pierret (fepitre) ]
  * Step back for jammy on pipewire
  * pipewire: drop service vm to be set
  * Update CI exclude for install

  [ Marek Marczykowski-Górecki ]
  * Cleanup unused file

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 16 May 2023 04:23:02 +0200

=== debian/control ===
--- 
+++ 
@@ -101,6 +101,7 @@
     ${shlibs:Depends},
     ${pulse:Depends},
     ${misc:Depends},
+Conflicts: pipewire-qubes
 Replaces:
  qubes-gui-agent (<< 4.1.9-1),
  qubes-core-agent (<< 4.2.5-1),
@@ -116,6 +117,7 @@
  qubesdb-vm (>= 4.1.4),
  ${shlibs:Depends},
  ${misc:Depends}
+Conflicts: pulseaudio-qubes
 Recommends: pipewire-pulse
 Description: PipeWire module to enable sound support in Qubes VM
  Experimental PipeWire module to enable sound support in Qubes VMs.
